# Uses of Interface
java.lang.classfile.Signature

Packages that use Signature
Package
Description
java.lang.classfile
Provides classfile parsing, generation, and transformation library.
java.lang.classfile.attribute
Provides interfaces describing `class` file attributes for the `java.lang.classfile` library.
java.lang.classfile.instruction
Provides interfaces describing code instructions for the `java.lang.classfile` library.

## Uses of Signature in java.lang.classfile

Subinterfaces of Signature in java.lang.classfile
Modifier and Type
Interface
Description
`static interface`
`Signature.ArrayTypeSig`
Models the signature of an array type.
`static interface`
`Signature.BaseTypeSig`
Models the signature of a primitive type (JLS §4.2) or void.
`static interface`
`Signature.ClassTypeSig`
Models the signature of a possibly-parameterized class or interface type.
`static interface`
`Signature.RefTypeSig`
Models the signature of a reference type, which may be a class, interface, type variable, or array type.
`static interface`
`Signature.ThrowableSig`
Marker interface for a signature for a throwable type.
`static interface`
`Signature.TypeVarSig`
Models the signature of a type variable.
Methods in java.lang.classfile that return Signature
Modifier and Type
Method
Description
`Signature`
Signature.ArrayTypeSig.`componentSignature()`
Returns the signature of the component type.
`static Signature`
Signature.`of(ClassDesc classDesc)`
Returns a Java type signature from a field descriptor.
`static Signature`
Signature.`parseFrom(String javaTypeSignature)`
Parses a Java type signature from a raw string.
`Signature`
MethodSignature.`result()`
Returns the signatures of the return value of this method.
Methods in java.lang.classfile that return types with arguments of type Signature
Modifier and Type
Method
Description
`List<Signature>`
MethodSignature.`arguments()`
Returns the signatures of the parameters of this method or constructor, may be empty.
Methods in java.lang.classfile with parameters of type Signature
Modifier and Type
Method
Description
`default CodeBuilder`
CodeBuilder.`localVariableType(int slot, String name, Signature signature, Label startScope, Label endScope)`
Declares a local variable type entry.
`static MethodSignature`
MethodSignature.`of(Signature result, Signature... arguments)`
Returns a method signature with no type parameter or exception type.
`static MethodSignature`
MethodSignature.`of(List<Signature.TypeParam> typeParameters, List<Signature.ThrowableSig> exceptions, Signature result, Signature... arguments)`
Returns a method signature.
`static Signature.ArrayTypeSig`
Signature.ArrayTypeSig.`of(int dims, Signature componentSignature)`
Returns a signature for an array type.
`static Signature.ArrayTypeSig`
Signature.ArrayTypeSig.`of(Signature componentSignature)`
Returns an array type with the given component type.

## Uses of Signature in java.lang.classfile.attribute

Methods in java.lang.classfile.attribute that return Signature
Modifier and Type
Method
Description
`default Signature`
SignatureAttribute.`asTypeSignature()`
Parses the signature string as a Java type signature.
Methods in java.lang.classfile.attribute with parameters of type Signature
Modifier and Type
Method
Description
`static SignatureAttribute`
SignatureAttribute.`of(Signature signature)`
Returns a `Signature` attribute for a field or a record component.

## Uses of Signature in java.lang.classfile.instruction

Methods in java.lang.classfile.instruction that return Signature
Modifier and Type
Method
Description
`default Signature`
LocalVariableType.`signatureSymbol()`
Returns the local variable generic signature.
Methods in java.lang.classfile.instruction with parameters of type Signature
Modifier and Type
Method
Description
`static LocalVariableType`
LocalVariableType.`of(int slot, String name, Signature signature, Label startScope, Label endScope)`
Returns a local variable type pseudo-instruction.